#include "stdio.h"
#include "string.h"

const char device[]="PLX";

int main(){
  FILE * iomem;
  char line[80];
  unsigned long base,bound;
  unsigned long range=0;
  int nbases=0;

  if ((iomem = fopen("/proc/iomem","r"))!=NULL) {
    while ( fgets(line,sizeof(line),iomem) != NULL ) {
      sscanf(line,"%x-%x",&base,&bound);
      // find device if present 
      int len = strlen(device);
      if (strstr(line,device)) {
	range+=bound-base+1;
	printf("PLX base %d found %x-%x\n",nbases,base,bound);
	nbases++;
      }
    }
  }
  else {
    printf("Error, cannot open /proc/iomem\n");
    return 10;
  }
  if (nbases==0) {
    printf("Error, PLX not found!\n");
    return 2;
  }
  else if (nbases!=3) {
    printf("Error, Incorrect number of PLX bases!\n");
    return 3;
  }
  printf("Total PCI memory reserved for PLX = 0x%x\n",range);
  if (range<0x1000000) {
    printf("Warning PLX iomemory < 16MB!\n");
    return 1;
  }
  else printf("PLX is properly configured for running\n");
  return 0;
}
