#! /bin/sh

tmpfile=/tmp/plx_check.log

retries=0

if [ -e $tmpfile ] 
then
  echo $tmpfile exists, this is a 2nd boot attempt
  retries=1
fi

echo plx_check: This is boot attempt: $retries

~root/startup/plx_check > $tmpfile
status=$?
cat $tmpfile

echo status = $status

if [ $status -eq 1 ] 
then 
  if [ $retries -ne 0 ]
  then
    echo "1st reboot failed to correct PLX configuration"
    echo "Check this card for possible hardware problems"
  else
    echo "PLX config error - Rebooting..." 
    reboot
  fi
fi

if [ $status -eq 2 ]
then
  echo "No usable PLX device found"
fi

if [ $status -gt 2 ]
then
  echo "plx_check exits in error"
fi

if [ $status -eq 0 ]
then
  echo "Secondary PCI bus is properly configured"
fi

rm -f $tmpfile.1
cp $tmpfile $tmpfile.1
rm -f $tmpfile
